<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cyhal__crc_8h" kind="file" language="C++">
    <compoundname>cyhal_crc.h</compoundname>
    <includes local="no">stdint.h</includes>
    <includes local="no">stdbool.h</includes>
    <includes local="yes" refid="cy__result_8h">cy_result.h</includes>
    <includes local="yes" refid="cyhal__hw__types_8h">cyhal_hw_types.h</includes>
    <includedby local="yes" refid="cyhal__crc__impl_8h">cyhal_crc_impl.h</includedby>
    <includedby local="yes" refid="cyhal__drivers_8h">cyhal_drivers.h</includedby>
    <incdepgraph>
      <node id="51">
        <label>stdbool.h</label>
      </node>
      <node id="50">
        <label>stdint.h</label>
      </node>
      <node id="49">
        <label>cyhal_crc.h</label>
        <link refid="cyhal__crc_8h" />
        <childnode refid="50" relation="include">
        </childnode>
        <childnode refid="51" relation="include">
        </childnode>
      </node>
    </incdepgraph>
    <innerclass prot="public" refid="structcrc__algorithm__t">crc_algorithm_t</innerclass>
      <sectiondef kind="define">
      <memberdef id="group__group__hal__results__crc_1ga8f573a6a3660ae4086e9cde2da454324" kind="define" prot="public" static="no">
        <name>CYHAL_CRC_RSLT_ERR_BAD_ARGUMENT</name>
        <initializer>(CYHAL_RSLT_CREATE(<ref kindref="member" refid="group__group__result_1ga8d656d344524464af71296f2140a7b37">CY_RSLT_TYPE_ERROR</ref>, <ref kindref="member" refid="group__group__hal__results_1gga84f32ecb6376e2088d4f048e35f52005ab957798178a7d11049efcba5bf4887fc">CYHAL_RSLT_MODULE_CRC</ref>, 0))</initializer>
        <briefdescription>
<para>Invalid argument. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_crc.h" bodystart="72" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_crc.h" line="72" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__hal__crc_1gaf7d80ad97b75d1284db96b94274a837a" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_crc_init</definition>
        <argsstring>(cyhal_crc_t *obj)</argsstring>
        <name>cyhal_crc_init</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__crc__t">cyhal_crc_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Initialize the CRC generator. </para>        </briefdescription>
        <detaileddescription>
<para>This function reserves the CRYPTO block for CRC calculations.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="out">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a CRC generator object. The caller must allocate the memory for this object but the init function will initialize its contents. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the init request.</para></simplesect>
Returns <ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref> if the operation was successful. Refer <ref kindref="member" refid="group__group__hal__crc_1subsection_crc_snippet_1">Snippet1: CRC Generation</ref> for more information. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_crc.h" line="104" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__crc_1ga13e98c8757355f979fbe955d94763336" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_crc_free</definition>
        <argsstring>(cyhal_crc_t *obj)</argsstring>
        <name>cyhal_crc_free</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__crc__t">cyhal_crc_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Release the CRC generator. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="inout">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The CRC generator object </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_crc.h" line="110" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__crc_1gac4d388f57a325090b05d718d7f20e333" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_crc_start</definition>
        <argsstring>(cyhal_crc_t *obj, const crc_algorithm_t *algorithm)</argsstring>
        <name>cyhal_crc_start</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__crc__t">cyhal_crc_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>const <ref kindref="compound" refid="structcrc__algorithm__t">crc_algorithm_t</ref> *</type>
          <declname>algorithm</declname>
        </param>
        <briefdescription>
<para>The CRC block is setup to perform CRC computation. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="inout">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The CRC generator object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">algorithm</parametername>
</parameternamelist>
<parameterdescription>
<para>The CRC algorithm to use for computations Refer <ref kindref="compound" refid="structcrc__algorithm__t">crc_algorithm_t</ref>. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the compute request</para></simplesect>
Returns <ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref> if the operation was successful. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_crc.h" line="120" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__crc_1ga17e1a6544fecaa60880111d9ad2428f2" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_crc_compute</definition>
        <argsstring>(const cyhal_crc_t *obj, const uint8_t *data, size_t length)</argsstring>
        <name>cyhal_crc_compute</name>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__crc__t">cyhal_crc_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>const uint8_t *</type>
          <declname>data</declname>
        </param>
        <param>
          <type>size_t</type>
          <declname>length</declname>
        </param>
        <briefdescription>
<para>Computes the CRC for the given data and accumulates the CRC with the CRC generated from previous calls. </para>        </briefdescription>
        <detaileddescription>
<para>This function can be called multiple times to provide additional data. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Input data must be 4-byte aligned. Refer &lt;a href="#group__group__hal__crc_1subsection_crc_snippet_1"&gt;Snippet1: CRC Generation&lt;/a&gt; for more details. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The CRC generator object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">data</parametername>
</parameternamelist>
<parameterdescription>
<para>The input data </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">length</parametername>
</parameternamelist>
<parameterdescription>
<para>The number of bytes in the data </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the compute request</para></simplesect>
Returns <ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref> if the operation was successful. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_crc.h" line="132" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__crc_1ga2457c4fa6536551e89c21f9bd476c601" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_crc_finish</definition>
        <argsstring>(const cyhal_crc_t *obj, uint32_t *crc)</argsstring>
        <name>cyhal_crc_finish</name>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__crc__t">cyhal_crc_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint32_t *</type>
          <declname>crc</declname>
        </param>
        <briefdescription>
<para>Finalizes the CRC computation and returns the CRC for the complete set of data passed through a single call or multiple calls to <ref kindref="member" refid="group__group__hal__crc_1ga17e1a6544fecaa60880111d9ad2428f2">cyhal_crc_compute</ref>. </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The computed CRC pointer provided must be 4 byte aligned. Refer &lt;a href="#group__group__hal__crc_1subsection_crc_snippet_1"&gt;Snippet1: CRC Generation&lt;/a&gt; for more details.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The CRC generator object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">crc</parametername>
</parameternamelist>
<parameterdescription>
<para>The computed CRC </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the compute request</para></simplesect>
Returns <ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref> if the operation was successful. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_crc.h" line="143" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>Provides a high level interface for interacting with the CRC hardware accelerator. </para>    </briefdescription>
    <detaileddescription>
<para>This interface abstracts out the chip specific details. If any chip specific functionality is necessary, or performance is critical the low level functions can be used directly.</para><para><simplesect kind="copyright"><para>Copyright 2018-2020 Cypress Semiconductor Corporation SPDX-License-Identifier: Apache-2.0</para></simplesect>
Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at <verbatim>http://www.apache.org/licenses/LICENSE-2.0
</verbatim></para><para>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </para>    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/***************************************************************************/</highlight></codeline>
<codeline lineno="54"><highlight class="preprocessor">#pragma<sp />once</highlight><highlight class="normal" /></codeline>
<codeline lineno="55"><highlight class="normal" /></codeline>
<codeline lineno="56"><highlight class="normal" /><highlight class="preprocessor">#include<sp />&lt;stdint.h&gt;</highlight><highlight class="normal" /></codeline>
<codeline lineno="57"><highlight class="normal" /><highlight class="preprocessor">#include<sp />&lt;stdbool.h&gt;</highlight><highlight class="normal" /></codeline>
<codeline lineno="58"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_result.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="59"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_hw_types.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="60"><highlight class="normal" /></codeline>
<codeline lineno="61"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="62"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="63"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="64"><highlight class="normal" /></codeline>
<codeline lineno="72"><highlight class="preprocessor">#define<sp />CYHAL_CRC_RSLT_ERR_BAD_ARGUMENT<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />\</highlight></codeline>
<codeline lineno="73"><highlight class="preprocessor"><sp /><sp /><sp /><sp />(CYHAL_RSLT_CREATE(CY_RSLT_TYPE_ERROR,<sp />CYHAL_RSLT_MODULE_CRC,<sp />0))</highlight><highlight class="normal" /></codeline>
<codeline lineno="74"><highlight class="normal" /></codeline>
<codeline lineno="80" refid="structcrc__algorithm__t" refkind="compound"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal" /></codeline>
<codeline lineno="81"><highlight class="normal">{</highlight></codeline>
<codeline lineno="82"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />width;<sp /></highlight></codeline>
<codeline lineno="83"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />polynomial;<sp /></highlight></codeline>
<codeline lineno="84"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />lfsrInitState;<sp /></highlight></codeline>
<codeline lineno="85"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />dataXor;<sp /></highlight></codeline>
<codeline lineno="86"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />remXor;<sp /></highlight></codeline>
<codeline lineno="87"><highlight class="normal" /></codeline>
<codeline lineno="92"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />dataReverse;</highlight></codeline>
<codeline lineno="93"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />remReverse;<sp /></highlight></codeline>
<codeline lineno="94"><highlight class="normal">}<sp /><ref kindref="compound" refid="structcrc__algorithm__t">crc_algorithm_t</ref>;</highlight></codeline>
<codeline lineno="95"><highlight class="normal" /></codeline>
<codeline lineno="104"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__crc_1gaf7d80ad97b75d1284db96b94274a837a">cyhal_crc_init</ref>(<ref kindref="compound" refid="structcyhal__crc__t">cyhal_crc_t</ref><sp />*obj);</highlight></codeline>
<codeline lineno="105"><highlight class="normal" /></codeline>
<codeline lineno="110"><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__crc_1ga13e98c8757355f979fbe955d94763336">cyhal_crc_free</ref>(<ref kindref="compound" refid="structcyhal__crc__t">cyhal_crc_t</ref><sp />*obj);</highlight></codeline>
<codeline lineno="111"><highlight class="normal" /></codeline>
<codeline lineno="120"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__crc_1gac4d388f57a325090b05d718d7f20e333">cyhal_crc_start</ref>(<ref kindref="compound" refid="structcyhal__crc__t">cyhal_crc_t</ref><sp />*obj,<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcrc__algorithm__t">crc_algorithm_t</ref><sp />*algorithm);</highlight></codeline>
<codeline lineno="121"><highlight class="normal" /></codeline>
<codeline lineno="132"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__crc_1ga17e1a6544fecaa60880111d9ad2428f2">cyhal_crc_compute</ref>(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcyhal__crc__t">cyhal_crc_t</ref><sp />*obj,<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint8_t<sp />*data,<sp /></highlight><highlight class="keywordtype">size_t</highlight><highlight class="normal"><sp />length);</highlight></codeline>
<codeline lineno="133"><highlight class="normal" /></codeline>
<codeline lineno="143"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__crc_1ga2457c4fa6536551e89c21f9bd476c601">cyhal_crc_finish</ref>(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcyhal__crc__t">cyhal_crc_t</ref><sp />*obj,<sp />uint32_t<sp />*crc);</highlight></codeline>
<codeline lineno="144"><highlight class="normal" /></codeline>
<codeline lineno="145"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="146"><highlight class="normal">}</highlight></codeline>
<codeline lineno="147"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="148"><highlight class="normal" /></codeline>
<codeline lineno="149"><highlight class="normal" /><highlight class="preprocessor">#ifdef<sp />CYHAL_CRC_IMPL_HEADER</highlight><highlight class="normal" /></codeline>
<codeline lineno="150"><highlight class="normal" /><highlight class="preprocessor">#include<sp />CYHAL_CRC_IMPL_HEADER</highlight><highlight class="normal" /></codeline>
<codeline lineno="151"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />CYHAL_CRC_IMPL_HEADER<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="152"><highlight class="normal" /></codeline>
    </programlisting>
    <location file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_crc.h" />
  </compounddef>
</doxygen>